#! /bin/bash

# MIPS I system
# Copyright 2011-2012 Stefan Schuermans <stefan@blinkenarea.org>
# Copyleft GNU public license V2 or later
#          http://www.gnu.org/copyleft/gpl.html

cd "$(dirname "$0")"

DATA2MEM="/opt/Xilinx/13.4/ISE_DS/ISE/bin/lin64/data2mem"

cd ..

ERR=0

"$DATA2MEM" \
  -bm memory_maps/mips_sys_bd.bmm \
  -bt e_system.bit \
  -d >e_system.bit.txt

"$DATA2MEM" \
  -bm memory_maps/mips_sys_bd.bmm \
  -bt e_system.bit \
  -bd fw/rom.bin tag rom \
  -o b changed_rom.bit

"$DATA2MEM" \
  -bm memory_maps/mips_sys_bd.bmm \
  -bt changed_rom.bit \
  -d >changed_rom.bit.txt

N=$(diff e_system.bit.txt changed_rom.bit.txt | wc -l)
if (($N > 12))
then
  echo "ROM failed" >&2
  ERR=1
fi

"$DATA2MEM" \
  -bm memory_maps/mips_sys_bd.bmm \
  -bt e_system.bit \
  -bd fw/ram.bin tag ram \
  -o b changed_ram.bit

"$DATA2MEM" \
  -bm memory_maps/mips_sys_bd.bmm \
  -bt changed_ram.bit \
  -d >changed_ram.bit.txt

N=$(diff e_system.bit.txt changed_ram.bit.txt | wc -l)
if (($N > 12))
then
  echo "RAM failed" >&2
  ERR=1
fi

exit $ERR

